package eu.chorevolution.vsb.artifact.generators;

import java.io.File;

import eu.chorevolution.vsb.bc.manager.VsbOutput;
import eu.chorevolution.vsb.compiler.RunTimeCompiler;
import eu.chorevolution.vsb.gmdl.utils.Constants;
import eu.chorevolution.vsb.gmdl.utils.PathResolver;
import eu.chorevolution.vsb.gmdl.utils.enums.ProtocolType;

public class Generator {
	
	public Generator(){} 
	
	public void compileGeneratedClasses(Class[] classesOptions){
		
		 String sourceFilesPath = Constants.generatedCodePath + File.separator+ Constants.target_namespace_path;
		 RunTimeCompiler compiler = new RunTimeCompiler(sourceFilesPath,Constants.generatedCodePath,classesOptions);
		 compiler.compile();
		 File sourceDir = new File(sourceFilesPath); 
		 /*for(File f: sourceDir.listFiles()){
			 
			 if(f.getName().endsWith("java")){
				 
				 f.delete();
			 }
			       
		 }*/	   
		 PathResolver.setClassPath(Constants.generatedCodePath);
		
	}
	
	public VsbOutput generateWar(WarGenerator warGenerator, ProtocolType busProtocol){
		
		VsbOutput vsbOutput = warGenerator.generate(busProtocol == ProtocolType.SOAP);
		return vsbOutput;
	}
	
	public  byte[] generateJar(JarGenerator jarGenerator){
		
		return jarGenerator.generate();
	}
	
}
